	AREA gbacart, CODE, READONLY
	ENTRY

	IMPORT |Load$$ARM9_RW$$Base|
	IMPORT |Image$$ARM9_RW$$Base|
	IMPORT |Image$$ARM9_RW$$Length|
	IMPORT |Image$$ARM9_RW$$Limit|
	IMPORT |Image$$ARM9_RW$$ZI$$Base|
	IMPORT |Image$$ARM9_RW$$ZI$$Limit|

	IMPORT |Load$$ARM7_RW$$Base|
	IMPORT |Image$$ARM7_RW$$Base|
	IMPORT |Image$$ARM7_RW$$Length|
	IMPORT |Image$$ARM7_RW$$Limit|
	IMPORT |Image$$ARM7_RW$$ZI$$Base|
	IMPORT |Image$$ARM7_RW$$ZI$$Limit|

	IMPORT arm9main	
	IMPORT arm7main
	
	EXPORT bios_firmware_read
	EXPORT bios_SPI_write
;------------------------------------------------------------
 	b arm7init							;keep a valid GBA header to keep flash software happy

	DCB 36,255,174,81,105,154,162,33,61,132,130,10,132,228,9,173
	DCB 17,36,139,152,192,129,127,33,163,82,190,25,147,9,206,32
	DCB 16,70,74,74,248,39,49,236,88,199,232,51,130,227,206,191
	DCB 133,244,223,148,206,75,9,193,148,86,138,192,19,114,167,252
	DCB 159,132,77,115,163,202,154,97,88,151,163,39,252,3,152,118
	DCB 35,29,199,97,3,4,174,86,191,56,132,0,64,167,14,253
	DCB 255,82,254,3,111,149,48,241,151,251,192,133,96,214,128,37
	DCB 169,99,190,3,1,78,56,226,249,162,52,255,187,62,3,68
	DCB 120,0,144,203,136,17,58,148,101,192,124,99,135,240,60,175
	DCB 214,37,228,139,56,10,172,114,33,212,248,7
	;   "------------"
	DCB "noflashme   "	;title
	DCB "BOOT"		;gamecode
	DCB 0,0,0x96,0,0,0,0,0,0,0,0,0,0
	DCB 0x3c		;complement check
	DCW 0
;----------------------------------
arm7init

	mov	r0,#0x04000000
	add	r0,r0,#0x208
	strh r0,[r0]						;IME=0

	msr	cpsr_c,#0x13
	ldr	sp,=0x3810000-0x40				;set SVC (swi) stack
	msr	cpsr_c,#0x12
	ldr	sp,=0x3810000-0x80				;set IRQ stack
	msr	cpsr_c,#0x1f
	ldr	sp,=0x3810000-0x100				;set user stack

	ldr r1,=|Load$$ARM9_RW$$Base|
	ldr r2,=|Image$$ARM9_RW$$Base|
	ldr r3,=|Image$$ARM9_RW$$Limit|
_x	cmp r2,r3
	ldrcc r0,[r1],#4
	strcc r0,[r2],#4
	bcc _x

	ldr r1,=|Load$$ARM7_RW$$Base|
	ldr r2,=|Image$$ARM7_RW$$Base|
	ldr r3,=|Image$$ARM7_RW$$Limit|
_y	cmp r2,r3
	ldrcc r0,[r1],#4
	strcc r0,[r2],#4
	bcc _y

	mov r0,#0
	ldr r2,=|Image$$ARM9_RW$$ZI$$Base|
	ldr r3,=|Image$$ARM9_RW$$ZI$$Limit|
_1	cmp r2,r3
	strcc r0,[r2],#4
	bcc _1
	ldr r2,=|Image$$ARM7_RW$$ZI$$Base|
	ldr r3,=|Image$$ARM7_RW$$ZI$$Limit|
_2	cmp r2,r3
	strcc r0,[r2],#4
	bcc _2

 	ldr r0,=arm9init
 	ldr r1,=0x27ffe24
 	str r0,[r1]					;place ARM9 (passme)
	ldr r1,=0x2200008
 	str r0,[r1]					;place ARM9 (old style failsafe)
	
	adr lr,nowhere
	ldr r3,=arm7main
	bx r3

nowhere
	b nowhere
;-----------------------------------
	CODE16
bios_firmware_read
	ldr r3,=0x2437
	bx r3
bios_SPI_write
	ldr r3,=0x2369
	bx r3
;-----------------------------------
	AREA |.text|, CODE, READONLY
	CODE32
arm9init
	mov	r0,#0x04000000
	add	r0,r0,#0x208
	strh r0,[r0]						;IME=0

	msr	cpsr_c,#0x13
	ldr	sp,=0x804000-0x40				;set SVC (swi) stack
	msr	cpsr_c,#0x12
	ldr	sp,=0x804000-0x80				;set IRQ stack
	msr	cpsr_c,#0x1f
	ldr	sp,=0x804000-0x100				;set user stack

	ldr r1,=0x00002078					;disable DTCM and protection unit
	mcr p15,0,r1,c1,c0
	ldr r0,=0x0080000A
	mcr p15,0,r0,c9,c1					;TCM base = 0x00800*4096, size = 16 KB
	mrc p15,0,r0,c1,c0					;throw-away read of cp15.c1
	orr r1,r1,#0x10000
	mcr p15,0,r1,c1,c0					;cp15.c1 = 0x00012078;

	ldr pc,=arm9main
;-----------------
	END